local language = {

	-- MESSAGES
	MP_MSG_FIRSTSTART =
	"If you are using Mephisto for the first time please be sure to check out the FAQ and feature list on the %s page. Most questions are already answered there.",
	MP_MSG_ENOENT = "There is no such entry.",
	MP_MSG_ERROR = "ERROR!",
	MP_MSG_LOADSETUP = "Loading setup [%s] from [%s].",
	MP_MSG_LOADINFIGHT = "Loading setup [%s] from [%s] after combat.",
	MP_MSG_SAVESETUP = "Saving setup [%s].",
	MP_MSG_DELETESETUP = "Deleting setup [%s].",
	MP_MSG_EMPTYSETUP = "Setup is empty.",
	MP_MSG_FOODENOENT = "Could not find matching buff food in your inventory!",
	MP_MSG_NOFOODRUNNING = "No food running. Eat food and try again or drag & drop food onto food button.",
	MP_MSG_NOTFOOD = "This item is no buff food or is currently not supported.",
	MP_MSG_LOADSKILLS = "Loading skills %s from [%s].",
	MP_MSG_SAVESKILLS = "Saving skills to setup %s.",
	MP_MSG_SKILLENOENT = "Could not slot [%s]. Skill not unlocked.",
	MP_MSG_SKILLSTUCK = "Could not slot skill [%s].",
	MP_MSG_LOADGEAR = "Loading gear %s from [%s].",
	MP_MSG_SAVEGEAR = "Saving gear to setup %s.",
	MP_MSG_GEARENOENT = "Could not find %s in your inventory!",
	MP_MSG_GEARSTUCK = "Could not move item %s.",
	MP_MSG_FULLINV = "Your inventory is full. Gear may have not been moved properly.",
	MP_MSG_LOADCP = "Loading CP %s from [%s].",
	MP_MSG_SAVECP = "Saving CP to setup %s.",
	MP_MSG_CPENOENT = "Could not slot [%s]. Star is not unlocked.",
	MP_MSG_CPCOOLDOWN = "Champion points will be changed in %ss.",
	MP_MSG_CPCOOLDOWNOVER = "Champion points changed.",
	MP_MSG_TELEPORT_PLAYER = "Teleporting to %s.",
	MP_MSG_TELEPORT_WAYSHRINE = "Teleporting to wayshrine.",
	MP_MSG_TELEPORT_WAYSHRINE_ERROR = "Wayshrine not unlocked.",
	MP_MSG_TELEPORT_HOUSE = "Teleporting into primary residence.",
	MP_MSG_TOGGLEAUTOEQUIP = "%s auto-equip.",
	MP_MSG_TOGGLEAUTOEQUIP_ON = "Enabled",
	MP_MSG_TOGGLEAUTOEQUIP_OFF = "Disabled",
	MP_MSG_CLEARQUEUE = "Cleared %d queue entries.",
	MP_MSG_NOREPKITS = "Could not find any repair kits in your inventory!",
	MP_MSG_NOTENOUGHREPKITS = "Could not find enough repair kits in your inventory!",
	MP_MSG_NOSOULGEMS = "Could not find any soul gems in your inventory!",
	MP_MSG_NOTENOUGHSOULGEMS = "Could not find enough soul gems in your inventory!",
	MP_MSG_NOPOISONS = "Could not find any poisons in your inventory!",
	MP_MSG_IMPORTSUCCESS = "All items imported successfully.",
	MP_MSG_IMPORTGEARENOENT =
	"Not all items could be imported. Make sure you have all of the items in your inventory or in your bank. Traits don't matter.",
	MP_MSG_WITHDRAW_SETUP = "Withdrawing setup [%s] from bank.",
	MP_MSG_WITHDRAW_PAGE = "Withdrawing all setups of [%s] from bank.",
	MP_MSG_WITHDRAW_FULL = "Could not move items. Be sure there is enough space in your inventory.",
	MP_MSG_WITHDRAW_ENOENT = "Not all items could be found in the bank.",
	MP_MSG_DEPOSIT_SETUP = "Depositing setup [%s] to bank.",
	MP_MSG_DEPOSIT_PAGE = "Depositing all setups of [%s] from bank.",
	MP_MSG_DEPOSIT_FULL = "Could not deposit items to bank. Be sure there is enough space.",
	MP_MSG_TRANSFER_FINISHED = "All items were moved successfully.",
	MP_MSG_TRANSFER_TIMEOUT = "At least one item is stuck. Please try again.",
	MP_MSG_FOOD_FADED = "Your buff food ran out. Enjoy your %s!",
	MP_MSG_FOOD_COMBAT =
	"Your buff food just ran out mid combat. The wizard will provide you with %s after the combat if still needed.",
	MP_MSG_NOFOOD = "Could not find any matching buff food in your inventory!",
	MP_MSG_SWAPFAIL = "%s in your Setup failed to swap, attempting workaround, please wait a few seconds",
	MP_MSG_SWAPFAIL_DISABLED = "%s in your Setup failed to swap",
	MP_MSG_SWAPSUCCESS = "Setup successfully loaded",
	MP_MSG_SWAP_FIX_FAIL = "All workarounds have failed, please try to manually unequip the stuck piece",


	-- ADDON MENU
	MP_MENU_GENERAL = "General",
	MP_MENU_PRINTCHAT = "Print messages",
	MP_MENU_PRINTCHAT_TT =
	"Prints messages about loaded setups into the chat, the alert notifications or the center screen announcements",
	MP_MENU_PRINTCHAT_OFF = "Disabled",
	MP_MENU_PRINTCHAT_CHAT = "Chat",
	MP_MENU_PRINTCHAT_ALERT = "Alert",
	MP_MENU_PRINTCHAT_ANNOUNCEMENT = "Announcement",
	MP_MENU_OVERWRITEWARNING = "Show warning on overwrite",
	MP_MENU_OVERWRITEWARNING_TT = "Shows a warning if an already saved setup is overwritten.",
	MP_MENU_INVENTORYMARKER = "Inventory marker",
	MP_MENU_INVENTORYMARKER_TT = "Shows a small icon over items in the inventory that are saved in setups.",
	MP_MENU_UNEQUIPEMPTY = "Unequip empty slots",
	MP_MENU_UNEQUIPEMPTY_TT =
	"If something is saved as empty in the setup, the item/champion point/skill will be unequipped.",
	MP_MENU_IGNORE_TABARDS = "Ignore empty tabard slots",
	MP_MENU_IGNORE_TABARDS_TT = "If an outfit is saved with no tabard, don't remove any currently equipped tabard",
	MP_MENU_RESETUI = "Reset UI",
	MP_MENU_RESETUI_TT =
	"|cFF0000This resets the window and all its positions on the scenes.|r\nIt must then be opened again with /wizard or the hotkey.",
	MP_MENU_AUTOEQUIP = "Auto-Equip",
	MP_MENU_AUTOEQUIP_DESC = "These settings control what exactly is loaded/saved from the setup.",
	MP_MENU_AUTOEQUIP_GEAR = "Gear",
	MP_MENU_AUTOEQUIP_SKILLS = "Skills",
	MP_MENU_AUTOEQUIP_CP = "Champion points",
	MP_MENU_AUTOEQUIP_BUFFFOOD = "Buff food",
	MP_MENU_SUBSTITUTE = "Substitute setups",
	MP_MENU_SUBSTITUTE_OVERLAND = "Overland",
	MP_MENU_SUBSTITUTE_OVERLAND_TT = "Also includes delves and public dungeons.",
	MP_MENU_SUBSTITUTE_DUNGEONS = "Dungeons",
	MP_MENU_SUBSTITUTE_WARNING =
	"These options enable loading of substitute setups outside the supported zones. It is |cFF0000experimental|r and will not work on all bosses. New dungeons usually work better than old ones.",
	MP_MENU_PANEL = "Info panel",
	MP_MENU_PANEL_ENABLE = "Enable panel",
	MP_MENU_PANEL_ENABLE_TT =
	"Shows the set and page name as well as the current zone.\nA |cF8FF70yellow|r set name indicates a delayed loading of the setup. A |cFF7070red|r set name means that the current setup no longer matches the saved one.",
	MP_MENU_PANEL_MINI = "Lite mode",
	MP_MENU_PANEL_MINI_TT = "Hides icon and reduces the size of the panel.",
	MP_MENU_PANEL_LOCK = "Lock ui",
	MP_MENU_MODULES = "Modules",
	MP_MENU_CHARGEWEAPONS = "Automatically charge weapons",
	MP_MENU_REPAIRARMOR = "Automatically repair armor",
	MP_MENU_REPAIRARMOR_TT = "Repairing at vendor and using repair kits.",
	MP_MENU_FILLPOISONS = "Automatically refill poisons",
	MP_MENU_FILLPOISONS_TT =
	"Automatically tries to refill poisons from the inventory.\n|H1:item:76827:308:50:0:0:0:0:0:0:0:0:0:0:0:0:36:1:0:0:0:138240|h|h is also exchanged with |H1:item:79690:6:1:0:0:0:0:0:0:0:0:0:0:0:1:36:0:1:0:0:0|h|h (and vice versa) if otherwise not available.",
	MP_MENU_BUFFFOOD = "Automatically renew buff food",
	MP_MENU_BUFFFOOD_TT =
	"Automatically eats the matching food again when it runs out. Only works in trials and dungeons.\nLook into \"MephistoConst.lua\" to see which foods are supported. More to come.",
	MP_MENU_FIXES_FIXSURFINGWEAPONS = "Fix surfing on weapons",
	MP_MENU_FIXES_FIXSURFINGWEAPONS_TT =
	"This will toggle \"Hide Your Helm\" twice every zone swap in order to fix the weapon surf bug.",
	MP_MENU_WEAPON_GEAR_FIX = "Fix failed gear swaps.",
	MP_MENU_WEAPON_GEAR_FIX_TT = "Automates the steps we take to fix failed gear swaps",
	MP_MENU_VALIDATION_DELAY = "Validation delay",
	MP_MENU_VALIDATION_DELAY_TT = "Chose here the amount of MS after which the setup validation takes place",
	MP_MENU_VALIDATION_DELAY_WARN =
	"The longer the delay the lower the chance to have false positives. If its too low, it might cause unintended behavior.",
	MP_MENU_COMPARISON_DEPTH = "Comparison depth",
	MP_MENU_COMPARISON_DEPTH_EASY = "Easy",
	MP_MENU_COMPARISON_DEPTH_DETAILED = "Detailed",
	MP_MENU_COMPARISON_DEPTH_THOROUGH = "Thorough",
	MP_MENU_COMPARISON_DEPTH_STRICT = "Strict",
	MP_MENU_COMPARISON_DEPTH_EASY_TT = "Will only check the trait, the weapon type and the set.",
	MP_MENU_COMPARISON_DEPTH_DETAILED_TT = "Will check the trait, the weapon type the set and quality.",
	MP_MENU_COMPARISON_DEPTH_THOROUGH_TT = "Will check the trait, the weapon type the set, quality and enchantment.",
	MP_MENU_COMPARISON_DEPTH_STRICT_TT =
	"Will check if its the exact same piece of gear that was saved. Will fail if you change anything.",


	-- USER INTERFACE
	MP_CHANGELOG =
	"Attention! This update contains some major changes. Please read the current changelog as some things may now work differently from what they used to.",
	MP_BUTTON_HELP = "|cFFFFFF[Click]|r to open wiki",
	MP_BUTTON_SETTINGS = "Settings",
	MP_BUTTON_CLEARQUEUE = "Reset queue\n(Can be used if too many set changes have been queued.)",
	MP_BUTTON_UNDRESS = "Undress",
	MP_BUTTON_PREBUFF = "Prebuff",
	MP_BUTTON_LABEL = "|cFFFFFF[Click]|r to load setup",
	MP_BUTTON_BANKING = "|cFFFFFF[Click]|r to withdraw gear,\n|cFFFFFF[Shift + Click]|r to deposit",
	MP_BUTTON_PREVIEW = "Preview",
	MP_BUTTON_SAVE = "Save",
	MP_BUTTON_MODIFY = "Modify",
	MP_BUTTON_RENAME = "Rename",
	MP_BUTTON_REARRANGE = "Rearrange",
	MP_BUTTON_TELEPORT = "Teleport",
	MP_BUTTON_TOGGLEAUTOEQUIP = "Toggle auto-equip",
	MP_BUTTON_ADDPAGE = "Add page",
	MP_BUTTON_ADDSETUP = "Add setup",
	MP_BUTTON_GEAR =
	"No gear saved!\nPress |cFFFFFF[Shift + Click]|r to save current gear or drag & drop items onto this button.",
	MP_BUTTON_SKILLS =
	"No skills saved!\nPress |cFFFFFF[Shift + Click]|r to save current hotbars or drag & drop spells onto this button.",
	MP_BUTTON_CP = "No CPs saved!\nPress |cFFFFFF[Shift + Click]|r to save current slottables.",
	MP_BUTTON_BUFFFOOD =
	"No buff food saved!\nPress |cFFFFFF[Shift + Click]|r to save current food or drag & drop food onto this button.",
	MP_RENAME_PAGE = "Enter new name for page:",
	MP_DELETEPAGE_WARNING = "Really delete page [%s]?",
	MP_OVERWRITESETUP_WARNING = "Really overwrite setup [%s]?",
	MP_DELETE = "Delete",
	MP_ENABLE = "Enable",
	MP_DISABLE = "Disable",
	MP_MISSING_GEAR_TT = "Following items are missing:\n\n%s\n\n|cFFFFFF[Click]|r to refresh",
	MP_SUBSTITUTE_EXPLAIN =
	"These setups are loaded if there is no setup stored on the selected trial page.\nIf you don't want to use this feature, just leave it empty.",
	MP_CONDITION_NAME = "Name",
	MP_CONDITION_BOSS = "Boss",
	MP_CONDITION_AFTER = "After",
	MP_CONDITION_NONE = "None",
	MP_CONDITION_EVERYWHERE = "Everywhere",
	MP_IMPORT = "Import",
	MP_IMPORT_HELP =
	"Paste |cFFFFFF[CTRL + V]|r the exported text here. Make sure that the text is not manipulated, otherwise the import may fail.\nYou need all items in the inventory. The traits of the exported setup will be prioritized, but if the item in the inventory does not have the correct trait, items with a \"wrong\" trait will also be used.",
	MP_IMPORT_TT = "|cFF0000Attention! This will overwrite the selected setup.|r",
	MP_EXPORT = "Export",
	MP_EXPORT_HELP =
	"Copy the selected text with |cFFFFFF[CTRL + C]|r and share it with others.\nIt contains gear, skills and champion points in a compact format to import it elsewhere.",
	MP_CUSTOMCODE = "Lua Code",
	MP_CUSTOMCODE_HELP = "This code is executed after the setup is loaded.",
	MP_DUPLICATE = "Duplicate",
	MP_DUPLICATE_NAME = "Copy of %s",
	MP_LINK_IMPORT = "Add to Wardrobe",
	MP_PREBUFF_HELP =
	"Drag and drop spells onto the prebuff bars.\nIf toggle is checked it will keep the prebuff spells on your hotbar until you press that hotbar again. Otherwise it will be unslotted after casting.\nDelay for \"normal\" spells is ~500ms, channeled abilities need more.",
	MP_MENU_HEADER_DUNGEON = "Dungeon Custom Profiles",

	-- BOSS & TRIAL NAMES
	MP_PAGE                    = "Page %s",
	MP_EMPTY                   = "Empty",
	MP_UNNAMED                 = "Unnamed",
	MP_TRASH                   = "Trash",

	MP_SUB_NAME                = "Substitute Setups",
	MP_SUB_BOSS                = "Substitute Boss",
	MP_SUB_TRASH               = "Substitute Trash",

	MP_GENERAL                 = "General",

	MP_PVP_NAME                = "Player versus Player",

	MP_AA_NAME                 = "Aetherian Archive",
	MP_AA_STORMATRO            = "Lightning Storm Atronach",
	MP_AA_STONEATRO            = "Foundation Stone Atronach",
	MP_AA_VARLARIEL            = "Varlariel",
	MP_AA_MAGE                 = "The Mage",

	MP_SO_NAME                 = "Sanctum Ophidia",
	MP_SO_MANTIKORA            = "Possessed Mantikora",
	MP_SO_TROLL                = "Stonebreaker",
	MP_SO_OZARA                = "Ozara",
	MP_SO_SERPENT              = "The Serpent",

	MP_HRC_NAME                = "Hel Ra Citadel",
	MP_HRC_RAKOTU              = "Ra Kotu",
	MP_HRC_LOWER               = "Yokeda Rok'dun",
	MP_HRC_UPPER               = "Yokeda Kai",
	MP_HRC_WARRIOR             = "The Warrior",

	MP_MOL_NAME                = "Maw of Lokhaj",
	MP_MOL_ZHAJHASSA           = "Zhaj'hassa the Forgotten",
	MP_MOL_TWINS               = "Twins",
	MP_MOL_RAKKHAT             = "Rakkhat",

	MP_HOF_NAME                = "Halls of Fabrication",
	MP_HOF_HUNTERKILLER        = "Hunter-Killer Negatrix",
	MP_HOF_HUNTERKILLER_DN     = "Hunter-Killer",
	MP_HOF_FACTOTUM            = "Pinnacle Factotum",
	MP_HOF_SPIDER              = "Archcustodian",
	MP_HOF_COMMITEE            = "Reactor",
	MP_HOF_COMMITEE_DN         = "Commitee",
	MP_HOF_GENERAL             = "Assembly General",

	MP_AS_NAME                 = "Asylum Sanctorium",
	MP_AS_OLMS                 = "Saint Olms the Just",
	MP_AS_FELMS                = "Saint Felms the Bold",
	MP_AS_LLOTHIS              = "Saint Llothis the Pious",

	MP_CR_NAME                 = "Cloudrest",
	MP_CR_GALENWE              = "Shade of Galenwe",
	MP_CR_RELEQUEN             = "Shade of Relequen",
	MP_CR_SIRORIA              = "Shade of Siroria",
	MP_CR_ZMAJA                = "Z'Maja",

	MP_SS_NAME                 = "Sunspire",
	MP_SS_LOKKESTIIZ           = "Lokkestiiz",
	MP_SS_YOLNAHKRIIN          = "Yolnahkriin",
	MP_SS_NAHVIINTAAS          = "Nahviintaas",

	MP_KA_NAME                 = "Kyne's Aegis",
	MP_KA_YANDIR               = "Yandir the Butcher",
	MP_KA_VROL                 = "Captain Vrol",
	MP_KA_FALGRAVN             = "Lord Falgravn",

	MP_RG_NAME                 = "Rockgrove",
	MP_RG_OAXILTSO             = "Oaxiltso",
	MP_RG_BAHSEI               = "Flame-Herald Bahsei",
	MP_RG_XALVAKKA             = "Xalvakka",
	MP_RG_SNAKE                = "Basks-In-Snakes",
	MP_RG_ASHTITAN             = "Ash Titan",

	MP_DSR_NAME                = "Dreadsail Reef",
	MP_DSR_LYLANARTURLASSIL    = "Lylanar",
	MP_DSR_LYLANARTURLASSIL_DN = "Lylanar and Turlassil",
	MP_DSR_GUARDIAN            = "Reef Guardian",
	MP_DSR_TALERIA             = "Tideborn Taleria",
	MP_DSR_SAILRIPPER          = "Sail Ripper",
	MP_DSR_BOWBREAKER          = "Bow Breaker",

	MP_SE_NAME                 = "Sanity's Edge",
	MP_SE_DESCENDER            = "Spiral Descender",
	MP_SE_YASEYLA              = "Exarchanic Yaseyla",
	MP_SE_TWELVANE             = "Archwizard Twelvane",
	MP_SE_ANSUUL               = "Ansuul the Tormentor",

	-- Arena

	MP_MA_NAME                = "Maelstrom Arena",

	MP_VH_NAME                 = "Vateshran Hollows",

	MP_DSA_NAME                = "Dragonstar Arena",

	MP_BRP_NAME                = "Blackrose Prison",
	MP_BRP_FIRST               = "Battlemage Ennodius",
	MP_BRP_SECOND              = "Tames-The-Beast",
	MP_BRP_THIRD               = "Lady Minara",
	MP_BRP_FOURTH              = "All of them",
	MP_BRP_FIFTH               = "Drakeeh the Unchained",
	MP_BRP_FINALROUND          = "Final Round",

	-- DUNGEONS
	MP_WGT_NAME = "White Gold Tower",
	MP_WGT_THE_ADJUDICATOR  = "The Adjudicator",
	MP_WGT_TRIBOSS  = "",
	MP_WGT_THE_PLANAR_INHIBITOR  = "The Planar Inhibitor",
	MP_WGT_MOLAG_KENA = "Molag Kena",

	MP_ICP_NAME = "Imperial City Prison",
	MP_ICP_IBOMEZ_THE_FLESH_SCULPTOR = "Ibomez the Flesh Sculptor",
	MP_ICP_FLESH_ABOMINATION = "Flesh Abomination",
	MP_ICP_LORD_WARDEN_DUSK = "Lord Warden Dusk",

	MP_ROM_NAME = "Ruins of Mazzatun",
	MP_ROM_MIGHTY_CHUDAN = "Mighty Chudan",
	MP_ROM_XAL_NUR_THE_SLAVER = "Xal-Nur the Slaver",
	MP_ROM_TREE_MINDER_NA_KESH = "Tree-Minder Na-Kesh",

	MP_COS_NAME = "Cradle of Shadows",
	MP_COS_KHEPHIDAEN = "Khephidaen",
	MP_COS_DRANOS_VELEADOR = "Dranos Velador",
	MP_COS_VELIDRETH = "Velidreth",

	MP_FH_NAME = "Falkreath Hold",
	MP_FH_MORRIGH_BULLBLOOD = "Morrigh Bullblood",
	MP_FH_SIEGE_MAMMOTH = "Siege Mammoth",
	MP_FH_CERNUNNON = "Cernunnon",
	MP_FH_DEATHLORD_BJARFRUD_SKJORALMOR = "Deathlord Bjarfrud Skjoralmor",
	MP_FH_DOMIHAUS_THE_BLOODY_HORNED = "Domihaus the Bloody-Horned",

	MP_BF_NAME = "Bloodroot Forge",
	MP_BF_MATHGAMAIN = "Mathgamain",
	MP_BF_CAILLAOIFE = "Caillaoife",
	MP_BF_STONEHEARTH = "Stoneheart",
	MP_BF_GALCHOBHAR = "Galchobhar",
	MP_BF_GHERIG_BULLBLOOD = "Gherig Bullblood",
	MP_BF_EARTHGORE_AMALGAM = "Earthgore Amalgam",

	MP_FL_NAME = "Fang Lair",
	MP_FL_LIZABET_CHARNIS = "Lizabet Charnis",
	MP_FL_CADAVEROUS_BEAR = "Cadaverous Bear",
	MP_FL_CALUURION = "Caluurion",
	MP_FL_ULFNOR = "Ulfnor",
	MP_FL_THURVOKUN = "Thurvokun",

	MP_SCP_NAME = "Scalescaller Peak",
	MP_SCP_ORZUN_THE_FOUL_SMELLING = "Orzun the Foul-Smelling",
	MP_SCP_DOYLEMISH_IRONHEARTH = "Doylemish Ironheart",
	MP_SCP_MATRIACH_ALDIS = "Matriarch Aldis",
	MP_SCP_PLAGUE_CONCOCTER_MORTIEU = "Plague Concocter Mortieu",
	MP_SCP_ZAAN_THE_SCALECALLER = "Zaan the Scalecaller",

	MP_MHK_NAME = "Moon Hunter Keep",
	MP_MHK_JAILER_MELITUS = "Jailer Melitus",
	MP_MHK_HEDGE_MAZE_GUARDIAN = "Hedge Maze Guardian",
	MP_MHK_MYLENNE_MOON_CALLER = "Mylenne Moon-Caller",
	MP_MHK_ARCHIVIST_ERNADE = "Archivist Ernarde",
	MP_MHK_VYKOSA_THE_ASCENDANT = "Vykosa the Ascendant",

	MP_MOS_NAME = "March of Sacrifices",
	MP_MOS_WYRESS_RANGIFER = "Wyress Strigidae",
	MP_MOS_AGHAEDH_OF_THE_SOLSTICE = "Aghaedh of the Solstice",
	MP_MOS_DAGRUND_THE_BULKY = "Dagrund the Bulky",
	MP_MOS_TARCYR = "Tarcyr",
	MP_MOS_BALORGH = "Balorgh",

	MP_FV_NAME = "Frostvault",
	MP_FV_ICESTALKER = "Icestalker",
	MP_FV_WARLORD_TZOGVIN = "Warlord Tzogvin",
	MP_FV_VAULT_PROTECTOR = "Vault Protector",
	MP_FV_RIZZUK_BONECHILL = "Rizzuk Bonechill",
	MP_FV_THE_STONEKEEPER = "The Stonekeeper",

	MP_DOM_NAME = "Depths of Malatar",
	MP_DOM_THE_SCAVENGING_MAW = "The Scavenging Maw",
	MP_DOM_THE_WEEPING_WOMAN = "The Weeping Woman",
	MP_DOM_DARK_ORB = "Dark Orb",
	MP_DOM_KING_NARILMOR = "King Narilmor",
	MP_DOM_SYMPHONY_OF_BLADE = "Symphony of Blades",

	MP_LOM_NAME = "Lair of Maarselok",
	MP_LOM_SELENE = "Selene",
	MP_LOM_AZUREBLIGHT_LURCHER = "Azureblight Lurcher",
	MP_LOM_AZUREBLIGHT_CANCROID = "Azureblight Cancroid",
	MP_LOM_MAARSELOK = "Maarselok",
	MP_LOM_MAARSELOK_BOSS = "Maarselok (Boss)",

	MP_MGF_NAME = "Moongrave Fane",
	MP_MGF_RISEN_RUINS = "Risen Ruins",
	MP_MGF_DRO_ZAKAR = "Dro'zakar",
	MP_MGF_KUJO_KETHBA = "Kujo Kethba",
	MP_MGF_NISAAZDA = "Nisaazda",
	MP_MGF_GRUNDWULF = "Grundwulf",

	MP_IR_NAME = "Icereach",
	MP_IR_KJARG_THE_TUSKSCRAPER = "Kjarg the Tuskscraper",
	MP_IR_SISTER_SKELGA = "Sister Skelga",
	MP_IR_VEAROGH_THE_SHAMBLER = "Vearogh the Shambler",
	MP_IR_STORMBOND_REVENANT = "Stormborn Revenant",
	MP_IR_ICEREACH_COVEN = "Icereach Coven",

	MP_UHG_NAME = "Unhallowed Grave",
	MP_UHG_HAKGRYM_THE_HOWLER = "Hakgrym the Howler",
	MP_UHG_KEEPER_OF_THE_KILN = "Keeper of the Kiln",
	MP_UHG_ETERNAL_AEGIS = "Eternal Aegis",
	MP_UHG_ONDAGORE_THE_MAD = "Ondagore the Mad",
	MP_UHG_KJALNAR_TOMBSKALD = "Kjalnar Tombskald",
	MP_UHG_NABOR_THE_FORGOTTEN = "Nabor the Forgotten",
	MP_UHG_VORIA_THE_HEARTH_THIEF = "Voria the Heart-Thief",
	MP_UHG_VORIAS_MASTERPIECE = "Voria's Masterpiece",

	MP_SG_NAME = "Stone Garden",
	MP_SG_EXARCH_KRAGLEN = "Exarch Kraglen",
	MP_SG_STONE_BEHEMOTH = "Stone Behemoth",
	MP_SG_ARKASIS_THE_MAD_ALCHEMIST = "Arkasis the Mad Alchemist",

	MP_CT_NAME = "Castle Thorn",
	MP_CT_DREAD_TINDULRA = "Dread Tindulra",
	MP_CT_BLOOD_TWILIGHT = "Blood Twilight",
	MP_CT_VADUROTH = "Vaduroth",
	MP_CT_TALFYG = "Talfyg",
	MP_CT_LADY_THORN = "Lady Thorn",

	MP_BDV_NAME = "Black Drake Villa",
	MP_BDV_KINRAS_IRONEYE = "Kinras Ironeye",
	MP_BDV_CAPTAIN_GEMINUS = "Captain Geminus",
	MP_BDV_PYROTURGE_ENCRATIS = "Pyroturge Encratis",
	MP_BDV_AVATAR_OF_ZEAL = "Avatar of Zeal",
	MP_BDV_AVATAR_OF_VIGOR = "Avatar of Vigor",
	MP_BDV_AVATAR_OF_FORTITUDE = "Avatar of Fortitude",
	MP_BDV_SENTINEL_AKSALAZ = "Sentinel Aksalaz",

	MP_TC_NAME = "The Cauldron",
	MP_TC_OXBLOOD_THE_DEPRAVED = "Oxblood the Depraved",
	MP_TC_TASKMASTER_VICCIA = "Taskmaster Viccia",
	MP_TC_MOLTEN_GUARDIAN = "Molten Guardian",
	MP_TC_DAEDRIC_SHIELD = "Daedric Shield",
	MP_TC_BARON_ZAULDRUS = "Baron Zaudrus",

	MP_RPB_NAME = "Red Petal Bastion",
	MP_RPB_ROGERAIN_THE_SLY = "Rogerain the Sly",
	MP_RPB_ELIAM_MERICK = "Eliam Merick",
	MP_RPB_PRIOR_THIERRIC_SARAZEN = "Prior Thierric Sarazen",
	MP_RPB_WRAITH_OF_CROWS = "Wraith of Crows",
	MP_RPB_SPIDER_DEADRA = "Spider Daedra",
	MP_RPB_GRIEVIOUS_TWILIGHT = "Grievous Twilight",

	MP_DC_NAME = "Dread Cellar",
	MP_DC_SCORION_BROODLORD = "Scorion Broodlord",
	MP_DC_CYRONIN_ARTELLIAN = "Cyronin Artellian",
	MP_DC_MAGMA_INCARNATE = "Magma Incarnate",
	MP_DC_PURGATOR = "Purgator",
	MP_DC_UNDERTAKER = "Undertaker",
	MP_DC_GRIM_WARDEN = "Grim Warden",

	MP_CA_NAME ="Coral Arie",
	MP_CA_B1 ="Magligalig",
	MP_CA_B2 ="Sarydil",
	MP_CA_B3 ="Varallion",
	MP_CA_SCB1 ="Sword Guardian",
	MP_CA_SCB2 ="Staff Guardian",
	MP_CA_SCB3 ="Shield Guardian",
	MP_CA_SCB4 ="Z’baza",

	MP_SR_NAME = "Shipwright’s Regret",
	MP_SR_B1="Foreman Bradiggan",
	MP_SR_B2="Nazaray",
	MP_SR_B3="Captain Numirril",
	MP_SR_SCB1="Lost Maiden",
	MP_SR_SCB2="Shrouded Axeman",
	MP_SR_SCB3="Storm-Cursed Sailor",

	MP_ERE_NAME="Earthen Root Enclave",
	MP_ERE_B1="Corruption of Stone",
	MP_ERE_B2="Corruption of Root",
	MP_ERE_B3="Archdruid Devyric",
	MP_ERE_SCB1="Scaled Roots",
	MP_ERE_SCB2="Lutea",
	MP_ERE_SCB3="Jodoro",

	MP_GD_NAME="Graven Deep",
	MP_GD_B1="The Euphotic Gatekeeper",
	MP_GD_B2="Varzunon",
	MP_GD_B3="Zelvraak the Unbreathing",
	MP_GD_SCB1="Mzugru",
	MP_GD_SCB2="Xzyviian",
	MP_GD_SCB3="Chralzak",

	MP_BS_NAME="Bal Sunnar",
	MP_BS_B1="Kovan Giryon",
	MP_BS_B2="Roksa the Warped",
	MP_BS_B3="Matriarch Lladi Telvanni",
	MP_BS_SCB="Urvel Drath",

	MP_SH_NAME="Scrivener's Hall",
	MP_SH_B1="Riftmaster Maqri",
	MP_SH_B2="Ozezan the Inferno",
	MP_SH_B3="Valinna",

	MP_BV_NAME="Bedlam Veil",
	MP_BV_B1="Shattered Champion",
	MP_BV_B2="Darkshard",
	MP_BV_B3="The Blind",

	MP_OP_NAME="Oathsworn Pit",
	MP_OP_B1="Packmaster Rethelros & Malthil",
	MP_OP_B2="Anthelmir’s Construct",
	MP_OP_B3="Aradros the Awakened",
	MP_OP_MB1="Sluthrug the Bloodied",
	MP_OP_MB2="Bolg of Wicked Barbs",
	MP_OP_MB3="Grubduthag Many-Fates",


	-- KEYBINDS
	SI_BINDING_NAME_MP_HOTKEY_SHOW_UI = "Open Mephisto",
	SI_BINDING_NAME_MP_HOTKEY_FIXES_FLIP_SHOULDERS = "Fix Shoulder",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_1 = "Setup 1 (Trash)",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_2 = "Setup 2",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_3 = "Setup 3",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_4 = "Setup 4",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_5 = "Setup 5",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_6 = "Setup 6",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_7 = "Setup 7",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_8 = "Setup 8",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_9 = "Setup 9",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_10 = "Setup 10",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_11 = "Setup 11",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_12 = "Setup 12",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_13 = "Setup 13",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_14 = "Setup 14",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_15 = "Setup 15",
	SI_BINDING_NAME_MP_HOTKEY_PREBUFF_1 = "Prebuff 1",
	SI_BINDING_NAME_MP_HOTKEY_PREBUFF_2 = "Prebuff 2",
	SI_BINDING_NAME_MP_HOTKEY_PREBUFF_3 = "Prebuff 3",
	SI_BINDING_NAME_MP_HOTKEY_PREBUFF_4 = "Prebuff 4",
	SI_BINDING_NAME_MP_HOTKEY_PREBUFF_5 = "Prebuff 5",

	SI_BINDING_NAME_MP_HOTKEY_UNDRESS = "Undress",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_PREVIOUS = "Equip previous setup",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_CURRENT = "Reload current setup",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_NEXT = "Equip next setup",
	SI_BINDING_NAME_MP_HOTKEY_SETUP_FIX = "Try to fix failed setup swap"
}

for key, value in pairs( language ) do
	SafeAddVersion( key, 1 )
	ZO_CreateStringId( key, value )
end
